(******************************************************************************
 *                                                                            *
 *      ,  2002                                 *
 *                                                                            *
 *  :       wavread.pas                                                   *
 *  :     *.wav-                              *
 *                                                                            *
 ******************************************************************************)
unit wavread;

interface

uses
  windows,
  mmsystem;

type
  TWaveSoundRead = class
  public
    m_pwfx:     PWAVEFORMATEX;   //    WAVEFRMATEX
    m_hmmioIn:  HMMIO;           //   *.wav
    m_ckIn:     MMCKINFO;        //  RIFF
    m_ckInRIFF: MMCKINFO;        //    *.wav-
  public
    constructor Create();
    destructor  Destroy();
    function Open( strFileName: string ): Boolean;
    function Reset(): Boolean;
    function Read( nSizeToRead: UINT; pbData: PByte; pnSizeRead: PUINT ): Boolean;
    function Close(): Boolean;
  end;

implementation

uses
  lowfunc;



  
//------------------------------------------------------------------------------
// :      TWaveSoundRead.Create()
// :  
//------------------------------------------------------------------------------
constructor TWaveSoundRead.Create();
begin
  inherited Create();
  m_pwfx := nil;
end;




//------------------------------------------------------------------------------
// :      TWaveSoundRead.Destroy()
// :  
//------------------------------------------------------------------------------
destructor TWaveSoundRead.Destroy();
begin
  inherited Destroy();
  Close();
  m_pwfx := nil;
end;




//------------------------------------------------------------------------------
// :      TWaveSoundRead.Open()
// :    
//------------------------------------------------------------------------------
function TWaveSoundRead.Open( strFileName: string ): Boolean;
begin
  Result := FALSE;

  m_pwfx := nil;

  if FAILED( WaveOpenFile( PChar( strFileName ), @m_hmmioIn, @m_pwfx,
                           @m_ckInRIFF) ) then
     Exit;

  if not Reset() then
     Exit;

  Result := TRUE;
end;




//------------------------------------------------------------------------------
// :      TWaveSoundRead.Reset()
// :       
//------------------------------------------------------------------------------
function TWaveSoundRead.Reset(): Boolean;
begin
  Result := not FAILED( WaveStartDataRead( @m_hmmioIn, @m_ckIn, @m_ckInRIFF ) );
end;




//------------------------------------------------------------------------------
// :      TWaveSoundRead.Read()
// :    
//------------------------------------------------------------------------------
function TWaveSoundRead.Read( nSizeToRead: UINT; pbData: PByte;
                              pnSizeRead: PUINT ): Boolean;
begin
  Result := not FAILED( WaveReadFile( m_hmmioIn, nSizeToRead, pbData, @m_ckIn,
                                      pnSizeRead ) );
end;




//------------------------------------------------------------------------------
// :      TWaveSoundRead.Close()
// :  
//------------------------------------------------------------------------------
function TWaveSoundRead.Close(): Boolean;
begin
  mmioClose(m_hmmioIn, 0);
  Result := TRUE;
end;

end.
